using System;
using System.Runtime.Serialization;
using System.Xml;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationCOMMPREFList2019
{
    /// <summary>
    /// COMMPREFList
    /// </summary>
    [DataContract(Name = "COMMPREFList", Namespace = "http://www.sbr.gov.au/ato/commpreflist")]
    public class COMMPREFList
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public INT INT { get; set; }
    }
    
    [CollectionDataContract(Name = "CommunicationTypeCCollection", Namespace = "http://www.sbr.gov.au/ato/commpreflist", ItemName="CommunicationTypeC")]
    public class CommunicationTypeCCollection: List<string> {}
    
    [CollectionDataContract(Name = "PreferencesPreferredContactMethodCCollection", Namespace = "http://www.sbr.gov.au/ato/commpreflist", ItemName="PreferencesPreferredContactMethodC")]
    public class PreferencesPreferredContactMethodCCollection: List<string> {}

    /// <summary>
    /// Filters
    /// </summary>
    [DataContract(Name = "Filters", Namespace = "http://www.sbr.gov.au/ato/commpreflist")]
    public class Filters
    {

        /// <summary>
        /// Communication type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public CommunicationTypeCCollection CommunicationTypeCCollection { get; set; }

        /// <summary>
        /// Recipient preference
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string PreferencesPreferredRecipientC { get; set; }

        /// <summary>
        /// Communication recipient
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string CommunicationRecipientC { get; set; }

        /// <summary>
        /// Delivery channel
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public PreferencesPreferredContactMethodCCollection PreferencesPreferredContactMethodCCollection { get; set; }

        /// <summary>
        /// Last updated start date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string InteractionEffectiveStartD { get; set; }

        /// <summary>
        /// Last updated end date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string InteractionEffectiveEndD { get; set; }
    }

    /// <summary>
    /// Pagination
    /// </summary>
    [DataContract(Name = "Pagination", Namespace = "http://www.sbr.gov.au/ato/commpreflist")]
    public class Pagination
    {

        /// <summary>
        /// Record limit
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal InteractionRecordLimitCt { get; set; }

        /// <summary>
        /// Start record identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string InteractionStartRecordId { get; set; }
    }

    /// <summary>
    /// Intermediary
    /// </summary>
    [DataContract(Name = "INT", Namespace = "http://www.sbr.gov.au/ato/commpreflist")]
    public class INT
    {

        /// <summary>
        /// Australian Business Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Registered Agent Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TaxAgentNumberId { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 3)]
        public Filters Filters { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 4)]
        public Pagination Pagination { get; set; }
    }
}
 
