using System;
using System.Runtime.Serialization;
using System.Xml;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationCOMMPREFSubmit2019
{
    /// <summary>
    /// COMMPREFSubmit
    /// </summary>
    [DataContract(Name = "COMMPREFSubmit", Namespace = "http://www.sbr.gov.au/ato/commprefsubmit")]
    public class COMMPREFSubmit
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public INT INT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 2)]
        public RP RP { get; set; }
    }

    /// <summary>
    /// Intermediary Declaration
    /// </summary>
    [DataContract(Name = "Declaration", Namespace = "http://www.sbr.gov.au/ato/commprefsubmit")]
    public class Declaration
    {

        /// <summary>
        /// Intermediary signature indicator
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public bool StatementAcceptedI { get; set; }

        /// <summary>
        /// Intermediary identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string SignatoryIdentifierT { get; set; }
    }

    /// <summary>
    /// Intermediary
    /// </summary>
    [DataContract(Name = "INT", Namespace = "http://www.sbr.gov.au/ato/commprefsubmit")]
    public class INT
    {

        /// <summary>
        /// Australian Business Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Registered Agent Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TaxAgentNumberId { get; set; }

        /// <summary>
        /// Requesting practice defaults
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public bool? OrganisationDetailsWholeOfPracticeI { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 4)]
        public Declaration Declaration { get; set; }
    }

    /// <summary>
    /// Communication Preference
    /// </summary>
    [CollectionDataContract(Name = "CommunicationPreferenceCollection", Namespace = "http://www.sbr.gov.au/ato/commprefsubmit", ItemName="CommunicationPreference" )]
    public class CommunicationPreferenceCollection: List<CommunicationPreference> {}

    /// <summary>
    /// Communication Preference
    /// </summary>
    [DataContract(Name = "CommunicationPreference", Namespace = "http://www.sbr.gov.au/ato/commprefsubmit")]
    public class CommunicationPreference
    {

        /// <summary>
        /// Communication type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string CommunicationTypeC { get; set; }

        /// <summary>
        /// Recipient preference
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string PreferencesPreferredRecipientC { get; set; }

        /// <summary>
        /// Account identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string TaxAccountId { get; set; }

        /// <summary>
        /// Last updated date and time
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public DateTime? PreferencesUpdateDt { get; set; }
    }

    /// <summary>
    /// Reporting Party
    /// </summary>
    [DataContract(Name = "RP", Namespace = "http://www.sbr.gov.au/ato/commprefsubmit")]
    public class RP
    {

        /// <summary>
        /// Tax File Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string TaxFileNumberId { get; set; }

        /// <summary>
        /// Australian Business Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string AustralianBusinessNumberId { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 3)]
        public CommunicationPreferenceCollection CommunicationPreferenceCollection { get; set; }
    }
}
 
